"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.removeTagFromCommentsOf = void 0;
/**
 * Removes a possible tag from the comments of the given reflection.
 * @param reflection The reflection from which the tag should be removed.
 * @param tagToRemove Name of the tag to be removed.
 */
function removeTagFromCommentsOf(reflection, tagToRemove) {
    var _a, _b, _c;
    tagToRemove = tagToRemove.toLowerCase();
    const tagIndex = (_b = (_a = reflection.comment) === null || _a === void 0 ? void 0 : _a.tags.findIndex((tag) => tag.tagName.toLowerCase() === tagToRemove)) !== null && _b !== void 0 ? _b : -1;
    if (tagIndex !== -1) {
        (_c = reflection.comment) === null || _c === void 0 ? void 0 : _c.tags.splice(tagIndex, 1);
    }
}
exports.removeTagFromCommentsOf = removeTagFromCommentsOf;
